Index: main/plugin-cms/i18n/messages_en.xml
===================================================================
--- main/plugin-cms/i18n/messages_en.xml	(revision 26702)
+++ main/plugin-cms/i18n/messages_en.xml	(working copy)
@@ -2126,6 +2126,8 @@
 	<message key="PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION">This button is disabled because the selected resource is not modifiable.</message>
 	<message key="PLUGINS_CMS_EXPLORER_NO_TRAVERSABLE_DESCRIPTION">This button is disabled because the selected resource does not allow to create a new directory or resource.</message>
     
+    <message key="PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION">This button is disabled because the selected content is locked by another user.</message>
+    
     <message key="PLUGINS_CMS_HELPER_CHOOSERESOURCESEXPLORERTREE_ERROR">Unable to initialize file explorer</message>
     <message key="PLUGINS_CMS_RESOURCECOLLECTION_MESSAGETARGET_BUS_ERROR">An error occurred : unable to select resource.</message>
     <message key="PLUGINS_CMS_RESOURCECOLLECTION_NOT_FOUND">Selection error.</message>
Index: main/plugin-cms/i18n/messages_fr.xml
===================================================================
--- main/plugin-cms/i18n/messages_fr.xml	(revision 26702)
+++ main/plugin-cms/i18n/messages_fr.xml	(working copy)
@@ -2125,6 +2125,8 @@
 	<message key="PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION">Ce bouton est désactivé car la ressource sélectionnée n'est pas modifiable.</message>
 	<message key="PLUGINS_CMS_EXPLORER_NO_TRAVERSABLE_DESCRIPTION">Ce bouton est désactivé car la ressource sélectionnée ne permet pas de créer un nouveau répertoire ou un fichier.</message>
     
+	<message key="PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION">Ce bouton est désactivé car le contenu est verrouillé par un autre utilisateur.</message>
+    
     <message key="PLUGINS_CMS_HELPER_CHOOSERESOURCESEXPLORERTREE_ERROR">Impossible d'initialiser l'arbre de l'explorateur de ressources</message>
     <message key="PLUGINS_CMS_RESOURCECOLLECTION_MESSAGETARGET_BUS_ERROR">Une erreur est survenue : elle a empêché la sélection de la ressource de se terminer correctement</message>
     <message key="PLUGINS_CMS_RESOURCECOLLECTION_NOT_FOUND">Erreur de sélection.</message>
Index: main/plugin-cms/plugin.xml
===================================================================
--- main/plugin-cms/plugin.xml	(revision 26702)
+++ main/plugin-cms/plugin.xml	(working copy)
@@ -7502,6 +7502,8 @@
                     <no-modifiable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION</no-modifiable-description>
                     <enabled-on-traversable-only>true</enabled-on-traversable-only>
                     <no-traversable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_TRAVERSABLE_DESCRIPTION</no-traversable-description>
+                    <enabled-on-parent-unlocked-only>true</enabled-on-parent-unlocked-only>
+                    <parent-locked-description i18n="true">PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION</parent-locked-description>
                     
                     <icon-small file="true" plugin="explorer">img/resources/folder_new_16.png</icon-small>
                     <icon-medium file="true" plugin="explorer">img/resources/folder_new_32.png</icon-medium>
@@ -7533,6 +7535,8 @@
                     <enable-on-modifiable-only>true</enable-on-modifiable-only>
                     <no-modifiable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION</no-modifiable-description>
                     <disabled-on-root>true</disabled-on-root>
+                    <enabled-on-parent-unlocked-only>true</enabled-on-parent-unlocked-only>
+                    <parent-locked-description i18n="true">PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION</parent-locked-description>
 					
                     <icon-small file="true" plugin="explorer">img/resources/folder_rename_16.png</icon-small>
                     <icon-medium file="true" plugin="explorer">img/resources/folder_rename_32.png</icon-medium>
@@ -7564,6 +7568,8 @@
                     <enable-on-modifiable-only>true</enable-on-modifiable-only>
                     <no-modifiable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION</no-modifiable-description>
                     <disabled-on-root>true</disabled-on-root>
+                    <enabled-on-parent-unlocked-only>true</enabled-on-parent-unlocked-only>
+                    <parent-locked-description i18n="true">PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION</parent-locked-description>
 					
 					<param name="icon-small" file="true" plugin="explorer">img/resources/folder_delete_16.png</param>
 					<param name="icon-medium" file="true" plugin="explorer">img/resources/folder_delete_32.png</param>
@@ -7652,6 +7658,8 @@
                     <no-modifiable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION</no-modifiable-description>
                     <enabled-on-traversable-only>true</enabled-on-traversable-only>
                     <no-traversable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_TRAVERSABLE_DESCRIPTION</no-traversable-description>
+                    <enabled-on-parent-unlocked-only>true</enabled-on-parent-unlocked-only>
+                    <parent-locked-description i18n="true">PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION</parent-locked-description>
                     
                     <icon-small file="true" plugin="explorer">img/resources/file_new_16.png</icon-small>
                     <icon-medium file="true" plugin="explorer">img/resources/file_new_32.png</icon-medium>
@@ -7683,6 +7691,8 @@
                     
                     <enable-on-modifiable-only>true</enable-on-modifiable-only>
                     <no-modifiable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION</no-modifiable-description>
+                    <enabled-on-parent-unlocked-only>true</enabled-on-parent-unlocked-only>
+                    <parent-locked-description i18n="true">PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION</parent-locked-description>
                     
 					<icon-small file="true" plugin="explorer">img/resources/file_rename_16.png</icon-small>
                     <icon-medium file="true" plugin="explorer">img/resources/file_rename_32.png</icon-medium>
@@ -7714,6 +7724,8 @@
                     
                     <enable-on-modifiable-only>true</enable-on-modifiable-only>
                     <no-modifiable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION</no-modifiable-description>
+                    <enabled-on-parent-unlocked-only>true</enabled-on-parent-unlocked-only>
+                    <parent-locked-description i18n="true">PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION</parent-locked-description>
                     
                     <icon-small file="true" plugin="explorer">img/resources/file_delete_16.png</icon-small>
                     <icon-medium file="true" plugin="explorer">img/resources/file_delete_32.png</icon-medium>
@@ -7768,6 +7780,8 @@
                     
                     <enable-on-modifiable-only>true</enable-on-modifiable-only>
                     <no-modifiable-description i18n="true">PLUGINS_CMS_EXPLORER_NO_MODIFIABLE_DESCRIPTION</no-modifiable-description>
+                    <enabled-on-parent-unlocked-only>true</enabled-on-parent-unlocked-only>
+                    <parent-locked-description i18n="true">PLUGINS_CMS_ATTACHMENT_CONTENT_LOCKED_DESCRIPTION</parent-locked-description>
                     
                     <param name="icon-small" file="true" plugin="explorer">img/resources/dublincore_16.png</param>
                     <param name="icon-medium" file="true" plugin="explorer">img/resources/dublincore_32.png</param>
Index: main/plugin-cms/resources/js/Ametys/cms/explorer/ExplorerNode.js
===================================================================
--- main/plugin-cms/resources/js/Ametys/cms/explorer/ExplorerNode.js	(revision 26702)
+++ main/plugin-cms/resources/js/Ametys/cms/explorer/ExplorerNode.js	(working copy)
@@ -85,6 +85,24 @@
 			/** @ignore */
 			canCreateChild: false,
 			/**
+			 * @cfg {boolean} parentIsLocked True if the parent node is locked.
+			 */
+			/**
+			 * @method getParentIsLocked Get the #cfg-parentIsLocked
+			 * @return {boolean} The parent is locked status
+			 */
+			/** @ignore */
+			parentIsLocked: false,
+			/**
+			 * @cfg {boolean} canUnlockParent True if the parent can be unlocked by the current user.
+			 */
+			/**
+			 * @method getCanUnlockParent Get the #cfg-canUnlockParent
+			 * @return {boolean} The canUnlockParent status
+			 */
+			/** @ignore */
+			canUnlockParent: false,
+			/**
 			 * @cfg {String} applicationId The id of application the explorer node belongs to.
 			 */
 			/**
@@ -139,6 +157,8 @@
 				path: this.path,
 				isModifiable : this.isModifiable,
 				canCreateChild : this.canCreateChild,
+				parentIsLocked: this.parentIsLocked,
+				canUnlockParent: this.canUnlockParent,
 				rights: this.rights
 			}, initialProperty);
 		}
Index: main/plugin-cms/resources/js/Ametys/cms/explorer/Resource.js
===================================================================
--- main/plugin-cms/resources/js/Ametys/cms/explorer/Resource.js	(revision 26702)
+++ main/plugin-cms/resources/js/Ametys/cms/explorer/Resource.js	(working copy)
@@ -75,6 +75,24 @@
 			 */
 			/** @ignore */
 			isModifiable: false,
+            /**
+             * @cfg {boolean} parentIsLocked True if the parent node is locked.
+             */
+            /**
+             * @method getParentIsLocked Get the #cfg-parentIsLocked
+             * @return {boolean} The parent is locked status
+             */
+            /** @ignore */
+            parentIsLocked: false,
+            /**
+             * @cfg {boolean} canUnlockParent True if the parent can be unlocked by the current user.
+             */
+            /**
+             * @method getCanUnlockParent Get the #cfg-canUnlockParent
+             * @return {boolean} The canUnlockParent status
+             */
+            /** @ignore */
+            canUnlockParent: false,
 			/**
 			 * @cfg {String[]} rights List of the id of the rights the current user have on this resource
 			 */
@@ -119,6 +137,8 @@
 				name: this.name,
 				path: this.path,
 				isModifiable : this.isModifiable,
+                parentIsLocked: this.parentIsLocked,
+                canUnlockParent: this.canUnlockParent,
 				rights: this.rights
 			}, initialProperty);
 		}	
Index: main/plugin-cms/resources/js/Ametys/plugins/cms/explorer/controllers/ExplorerNodeController.js
===================================================================
--- main/plugin-cms/resources/js/Ametys/plugins/cms/explorer/controllers/ExplorerNodeController.js	(revision 26702)
+++ main/plugin-cms/resources/js/Ametys/plugins/cms/explorer/controllers/ExplorerNodeController.js	(working copy)
@@ -68,6 +68,10 @@
 		{
 			return this.getInitialConfig('no-traversable-description') || '';
 		}
+		else if (String(this.getInitialConfig('enabled-on-parent-unlocked-only')) == 'true' && target.getParameters().parentIsLocked && !target.getParameters().canUnlockParent)
+		{
+		    return this.getInitialConfig('parent-locked-description') || '';
+		}
 		else if (String(this.getInitialConfig("disabled-on-root")) == 'true' && this._isRoot (Ametys.message.MessageBus.getCurrentSelectionMessage(), target))
 		{
 			return "";